<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 17 januari 2009, 15:14</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef SYLPH_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define SYLPH_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "Sylph/OS/OS.h"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "Sylph/Core/Application.h"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "Sylph/Core/Array.h"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "Sylph/Core/String.h"</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include "<a class="code" href="_common_8h.html" title="This file is a shortcut to include many commonly used headers.">Sylph/Core/Common.h</a>"</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include "Sylph/Core/AppType.h"</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include "Sylph/Core/UncaughtExceptionHandler.h"</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifndef SYLPH_NO_SYLPHMAIN</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span><span class="preprocessor">#ifndef SYLPH_APP_NAME</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor">#define SYLPH_APP_NAME "Application"</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="preprocessor">#ifdef SYLPH_OS_MACOSX</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="keywordtype">int</span> main(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> * argv[], <span class="keywordtype">char</span> * envp[], <span class="keywordtype">char</span> * apple[]);
<a name="l00039"></a>00039 <span class="preprocessor">#else</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="keywordtype">int</span> main(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> * argv[]);
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> SylphInit(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> * argv[], <span class="keywordtype">char</span> * apple[]) {
<a name="l00043"></a>00043     <a class="code" href="class_sylph_1_1_application.html#4c4e7adbcf061be18bf1dd99fadf9c0c" title="Initialize the current application.">Sylph::Application::init</a>(argc, argv, apple, Sylph::SYLPH_APP_TYPE,
<a name="l00044"></a>00044             SYLPH_APP_NAME);
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 <span class="keyword">extern</span> <span class="keywordtype">int</span> SylphMain(<a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Sylph::Array&lt;Sylph::String&gt;</a> argv);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="preprocessor">#ifdef SYLPH_OS_MACOSX</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>
<a name="l00050"></a>00050 <span class="keywordtype">int</span> main(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> * argv[], <span class="keywordtype">char</span> * envp[], <span class="keywordtype">char</span> * apple[]) {
<a name="l00051"></a>00051     <span class="keywordflow">try</span> {
<a name="l00052"></a>00052         SylphInit(argc, argv, apple);
<a name="l00053"></a>00053         <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;String&gt;</a> args(argc);
<a name="l00054"></a>00054         <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = 0; i &lt; argc; ++i) {
<a name="l00055"></a>00055             args[i] = argv[i];
<a name="l00056"></a>00056         }
<a name="l00057"></a>00057         <span class="keywordflow">return</span> SylphMain(args);
<a name="l00058"></a>00058     } <span class="keywordflow">catch</span>(<span class="keyword">const</span> Sylph::Assertion&amp; as) {
<a name="l00059"></a>00059         Sylph::UncaughtExceptionHandler::handler-&gt;handleAssertion(as);
<a name="l00060"></a>00060         <span class="keywordflow">throw</span>;
<a name="l00061"></a>00061     } <span class="keywordflow">catch</span> (<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Sylph::Exception</a> &amp; ex) {
<a name="l00062"></a>00062         Sylph::UncaughtExceptionHandler::handler-&gt;handle(ex);
<a name="l00063"></a>00063         <span class="keywordflow">throw</span>;
<a name="l00064"></a>00064     }
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 <span class="preprocessor">#else</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <span class="keywordtype">int</span> main(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> * argv[]) {
<a name="l00069"></a>00069     <span class="keywordflow">try</span> {
<a name="l00070"></a>00070         SylphInit(argc, argv, Sylph::null);
<a name="l00071"></a>00071         <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;String&gt;</a> args(argc);
<a name="l00072"></a>00072         <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = 0; i &lt; argc; ++i) {
<a name="l00073"></a>00073             args[i] = argv[i];
<a name="l00074"></a>00074         }
<a name="l00075"></a>00075         <span class="keywordflow">return</span> SylphMain(args);
<a name="l00076"></a>00076     } <span class="keywordflow">catch</span>(<span class="keyword">const</span> Sylph::Assertion&amp; as) {
<a name="l00077"></a>00077         Sylph::UncaughtExceptionHandler::handler-&gt;handleAssertion(as);
<a name="l00078"></a>00078         <span class="keywordflow">throw</span>;
<a name="l00079"></a>00079     } <span class="keywordflow">catch</span> (<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_exception.html" title="This class provides a ready-to-use interface for exception handling.">Sylph::Exception</a> &amp; ex) {
<a name="l00080"></a>00080         Sylph::UncaughtExceptionHandler::handler-&gt;handle(ex);
<a name="l00081"></a>00081         <span class="keywordflow">throw</span>;
<a name="l00082"></a>00082     }
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 <span class="preprocessor">#endif</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span>
<a name="l00086"></a>00086 <span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span><span class="preprocessor">#endif  </span><span class="comment">/* SYLPH_H_ */</span>
<a name="l00088"></a>00088 
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
